window.Gleam.initSearch([{"doc":"gsiphash","title":"gsiphash","content":"# GSipHash\n\n[![Package Version](https://img.shields.io/hexpm/v/gsiphash)](https://hex.pm/packages/gsiphash)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gsiphash/)\n[![Package License](https://img.shields.io/hexpm/l/gsiphash)](https://hex.pm/packages/gsiphash)\n[![Package Total Downloads Count](https://img.shields.io/hexpm/dt/gsiphash)](https://hex.pm/packages/gsiphash)\n[![Build Status](https://img.shields.io/github/actions/workflow/status/BrendoCosta/gsiphash/test.yml)](https://hex.pm/packages/gsiphash)\n[![Total Stars Count](https://img.shields.io/github/stars/BrendoCosta/gsiphash)](https://hex.pm/packages/gsiphash)\n\n## Description\n\nGSipHash is a small Gleam library that ports to Gleam the SipHash family of non-cryptographic hash functions, developed by Jean-Philippe Aumasson and Daniel J. Bernstein in 2012. The basic implementation follows an earlier one I wrote in C++ based on reading the [original algorithm research paper](https://www.aumasson.jp/siphash/siphash.pdf) and the [C reference code](https://github.com/veorq/SipHash), but prioritizing code clarity over constants and shortcuts. The test code is taken from the [C reference test code](https://github.com/veorq/SipHash/blob/master/test.c).\n\n## Installation\n\n```sh\ngleam add gsiphash\n```\n\n## Usage\n\n```gleam\nimport gsiphash\n\npub fn main()\n{\n    let assert Ok(0x3eb7d9b19dbec827) = gsiphash.siphash_2_4(from: &lt;&lt;&quot;Hello world!&quot;:utf8&gt;&gt;, using: &lt;&lt;&quot;8027f33015eaaba5&quot;:utf8&gt;&gt;)\n    // The above function is an alias for calling the siphash function specifying 2 and 4 as the number of rounds C and D respectively.\n    let assert Ok(0x3eb7d9b19dbec827) = gsiphash.siphash(&lt;&lt;&quot;Hello world!&quot;:utf8&gt;&gt;, &lt;&lt;&quot;8027f33015eaaba5&quot;:utf8&gt;&gt;, 2, 4)\n}\n```\n\n## License\n\nGSipHash source code is avaliable under the [MIT license](/LICENSE).\n","url":"index.html"},{"doc":"gsiphash","title":"siphash","content":"pub fn siphash(\n  from data: BitArray,\n  using key: BitArray,\n  with_c_rounds c: Int,\n  with_d_rounds d: Int,\n) -&gt; Result(Int, String)\n\nSynonyms:\ngsiphash.siphash\ngsiphash siphash","url":"gsiphash.html#siphash"},{"doc":"gsiphash","title":"siphash_2_4","content":"pub fn siphash_2_4(\n  from data: BitArray,\n  using key: BitArray,\n) -&gt; Result(Int, String)\n\nSynonyms:\ngsiphash.siphash_2_4\ngsiphash siphash_2_4","url":"gsiphash.html#siphash_2_4"},{"doc":"gsiphash","title":"gsiphash","content":"","url":"gsiphash.html"}]);